1. [ ] 🐘 {+ DBRE +}: Check for potentially corrupt indexes:

    1. [ ] Build the amcheck VMs then trigger amcheck:

        1. [ ] Trigger a disk snapshot so we have recent data:
            1. [ ] SSH into each of the Backup nodes for Main and CI Patroni clusters:
                - [ ] `<%= amcheck_main_host %>-<%= env %>.c.<%= gcp_project %>.internal`
                - [ ] `<%= amcheck_ci_host %>-<%= env %>.c.<%= gcp_project %>.internal`

            1. [ ] Run `gcs-snapshot.sh` to create a disk snapshot:

                ```sh
                sudo su gitlab-psql -c /usr/local/bin/gcs-snapshot.sh
                ```

                Once the command has finished running, scroll back up and you'll see `Creating snapshot(s) <name>...` in the output. Take note of the name.

            1. [ ] Confirm the snapshots have been created by running the following from your machine:

                > NOTE: this step assumes you have your `gcloud` authenticated with access to GitLab projects:

                <%- [amcheck_main_host, amcheck_ci_host ].each do |srcdisk| -%>
                ```sh
                gcloud compute snapshots list --project <%= gcp_project %> --limit=1 --sort-by=~creationTimestamp --filter="sourceDisk~<%= srcdisk %> AND description~gcs-snapshot" --format="table[box,margin=3,title='Most recent snapshot'](name,creationTimestamp,sourceDisk,status)"
                ```
                <%- end -%>

                __Double-check that the output matches the snapshots you're expecting.__

    1. [ ] Perform the following steps from your `config-mgmt` repo directory on your machine:

        1. [ ] Get ready to run Terraform:

            ```sh
            cd environments/db-benchmarking
            tf init -upgrade
            ```

        1. [ ] Taint the `amcheck` VMs and data disks so they get recreated next time you apply:

            ```sh
            tf taint 'module.patroni-amcheck-main-<%= env %>-<%= amcheck_suffix ||= "1604" %>.google_compute_disk.data_disk["1"]'
            tf taint 'module.patroni-amcheck-main-<%= env %>-<%= amcheck_suffix ||= "1604" %>.google_compute_instance.instance_with_attached_disk["1"]'
            tf taint 'module.patroni-amcheck-ci-<%= env %>-<%= amcheck_suffix ||= "1604" %>.google_compute_disk.data_disk["1"]'
            tf taint 'module.patroni-amcheck-ci-<%= env %>-<%= amcheck_suffix ||= "1604" %>.google_compute_instance.instance_with_attached_disk["1"]'
            ```

            You'll get a `No such resource instance` error if the VM does not exist.

        1. [ ] Ensure you have a `nodes` map like the following for your `module "patroni-amcheck-..."` cluster definitions in `environments/db-benchmarking/main.tf`:

            ```text
            nodes = {
              1 = {}
            }
            ```

        1. [ ] Create the VMs to run `amcheck`:

            ```sh
            cd environments/db-benchmarking
            tf apply --target=module.patroni-amcheck-main-<%= env %>-<%= amcheck_suffix ||= "1604" %> --target=module.patroni-amcheck-ci-<%= env %>-<%= amcheck_suffix ||= "1604" %>
            ```

            This step will take a while (particularly in production).

        1. [ ] Wait until the nodes are ready for the next steps:

            1. [ ] SSH:
                - [ ] `patroni-amcheck-main-<%= env %>-<%= amcheck_suffix ||= "1604" %>-01-db-db-benchmarking.c.gitlab-db-benchmarking.internal`
                - [ ] `patroni-amcheck-ci-<%= env %>-<%= amcheck_suffix ||= "1604" %>-01-db-db-benchmarking.c.gitlab-db-benchmarking.internal`

                If you can't SSH in (permission denied), you'll have to wait until Chef has created the user accounts.
                If you still can't SSH in after 15-20mins, Chef may have failed. You'll need to look at the serial port output of the instance(s) via the GCP console and figure out why Chef failed to run:

                ```sh
                CLUSTER=main # or ci
                gcloud compute --project=gitlab-db-benchmarking instances get-serial-port-output patroni-amcheck-${CLUSTER}-<%= env %>-<%= amcheck_suffix ||= "1604" %>-01-db-db-benchmarking --zone=us-east1-c --port=1
                ```

            1. [ ] Check `/var/log/syslog` to confirm Chef has finished running:

                ```sh
                grep chef-client /var/log/syslog
                ```

                You'll want to see `Chef Client finished` in the output otherwise it's either still running or failed to run, and you'll need to figure out why.

    1. [ ] Run Ansible Playbook from your machine to setup Patroni cluster nodes in the `db-benchmarking` environment:

        1. [ ] Clone the `db-migration` repo:

            ```sh
            cd /path/to/your/repos
            git clone git@gitlab.com:gitlab-com/gl-infra/db-migration.git
            ```

        1. [ ] Execute playbook:

            ```sh
            export GCP_ENV="db-benchmarking"
            pushd db-migration/pg-os-upgrade
            ansible-playbook -i inventory/db-benchmarking-amcheck-<%= env %>-<%= amcheck_suffix ||= "1604" %>.yml playbooks/setup_environment.yml
            popd
            ```

    1. [ ] Run amcheck to identify potentially corrupt indexes:

        > __NOTE__: these steps can be executed in parallel (i.e., run `amcheck_parallel.sh` on the main & CI amcheck VMs in parallel):

        1. [ ] Copy contents of `db-migration` repo to the amcheck machines:

            ```sh
            rsync -avz db-migration/pg-os-upgrade patroni-amcheck-main-<%= env %>-<%= amcheck_suffix ||= "1604" %>-01-db-db-benchmarking.c.gitlab-db-benchmarking.internal:/var/tmp
            rsync -avz db-migration/pg-os-upgrade patroni-amcheck-ci-<%= env %>-<%= amcheck_suffix ||= "1604" %>-01-db-db-benchmarking.c.gitlab-db-benchmarking.internal:/var/tmp
            ```

        1. [ ] SSH into the VMs:
            - [ ] `patroni-amcheck-main-<%= env %>-<%= amcheck_suffix ||= "1604" %>-01-db-db-benchmarking.c.gitlab-db-benchmarking.internal`
            - [ ] `patroni-amcheck-ci-<%= env %>-<%= amcheck_suffix ||= "1604" %>-01-db-db-benchmarking.c.gitlab-db-benchmarking.internal`

        1. [ ] Trigger `amcheck_parallel.sh`:

            ```sh
            cd /var/tmp/pg-os-upgrade/playbooks/roles/patroni_os_upgrade/files/scripts
            <%= defined?(amcheck_limit) ? "LIMIT=#{amcheck_limit} " : "" %>./amcheck_parallel.sh
            ```

            The script will return immediately but it is running in the background.

        1. [ ] Monitor progress of `amcheck_parallel.sh` script:

            ```sh
            echo "SELECT COUNT(*) FROM pg_stat_activity WHERE clock_timestamp() - xact_start > interval '5 second' and query "'!~'" '^autovacuum'; \watch 10" | sudo gitlab-psql -tAX
            ```

            The number should eventually go down to `0` indicating that it has finished at which point you can just press `CTRL-C`.

            > You can also check the active processes writing to `amcheck-worker*.log` files:
            >
            > ```sh
            > watch -n 30 sudo fuser /var/tmp/amcheck-worker-*.log
            > ```

        1. [ ] Once `amcheck_parallel.sh` completes, gather the potentially corrupt indexes:

            ```sh
            sudo grep 'FAILED' /var/tmp/amcheck-worker-*.log
            ```

            1. [ ] Copy/paste the output from the previous command (from each amcheck host) into the issue.
        <%- if reindex_concurrently %>
        1. [ ] Login to the corresponding Patroni cluster leader node for which you have found potentially corrupt indexes. Create a script to reindex the potentially corrupt indexes using CONCURRENTLY option. Run the script using tmux session. Check for any errors in the log.

            ```sh
            vi /var/tmp/reindex.sql
            sudo gitlab-psql -f `pwd`/reindex.sql -o `pwd`/reindex.log # replace X with the modified script
            sudo grep -i 'error' /var/tmp/reindex.log
            ```

          If you see any errors then you'll have to rinse & repeat this section until there are no errors.
        <%- else %>
        1. [ ] Compare list of `FAILED` indexes in the output above to the arrays in the `reindex_*.sql` scripts:

            ```sh
            cd /path/to/repos
            cd db-migration/pg-os-upgrade/playbooks/roles/patroni_os_upgrade/files/sqls
            grep -iE "^\s+select unnest" reindex_*.sql
            ```

    1. [ ] If there are any changes to the list of potentially corrupt indexes:

        1. [ ] File an MR to update the `reindex_*.sql` scripts in the [Ansible playbook repo](https://gitlab.com/gitlab-com/gl-infra/db-migration/-/tree/master/pg-os-upgrade/playbooks/roles/patroni_os_upgrade/files/sqls) with the changes and get it reviewed/merged.

        1. [ ] Perform the `rsync` step again (on your machine) to update the `pg-os-upgrade` files on the `amcheck` hosts:

            ```sh
            rsync -avz db-migration/pg-os-upgrade patroni-amcheck-main-<%= env %>-01-db-db-benchmarking.c.gitlab-db-benchmarking.internal:/var/tmp
            rsync -avz db-migration/pg-os-upgrade patroni-amcheck-ci-<%= env %>-01-db-db-benchmarking.c.gitlab-db-benchmarking.internal:/var/tmp
            ```

        1. [ ] Confirm that the updated `reindex_*.sql` scripts have been uploaded to the amcheck hosts in `/var/tmp/pg-os-upgrade`

        1. [ ] Run the modified reindex script(s) manually on the `amcheck` host in question:

            ```sh
            cd /var/tmp/pg-os-upgrade/playbooks/roles/patroni_os_upgrade/files/sqls
            sudo gitlab-psql -f `pwd`/reindex_X.sql # replace X with the modified script
            ```

            If you see any errors then you'll have to rinse & repeat this section until there are no errors.
        <%- end %>

    <%- if defined?(amcheck_limit) %>
    1. [ ] Move worker log files:

        ```sh
        mkdir -p /var/tmp/amcheck-worker-logs-with-limit
        mv /var/tmp/amcheck-worker-*.log /var/tmp/amcheck-worker-logs-with-limit
        ```

    1. [ ] Trigger `amcheck_parallel.sh` again with an `OFFSET`:

        ```sh
        cd /var/tmp/pg-os-upgrade/playbooks/roles/patroni_os_upgrade/files/scripts
        OFFSET=<%= amcheck_limit %> ./amcheck_parallel.sh
        ```

        The script will return immediately but it is running in the background.

    1. [ ] Monitor progress of `amcheck_parallel.sh` script:

        ```sh
        echo "SELECT COUNT(*) FROM pg_stat_activity WHERE clock_timestamp() - xact_start > interval '5 second' and query "'!~'" '^autovacuum'; \watch 10" | sudo gitlab-psql -tAX
        ```

        The number should eventually go down to `0` indicating that it has finished at which point you can just press `CTRL-C`.

        > You can also check the active processes writing to `amcheck-worker*.log` files:
        >
        > ```sh
        > watch -n 30 sudo fuser /var/tmp/amcheck-worker-*.log
        > ```

    1. [ ] Once `amcheck_parallel.sh` completes, gather the potentially corrupt indexes:

        ```sh
        sudo grep 'FAILED' /var/tmp/amcheck-worker-*.log
        ```

    1. [ ] If you find any `FAILED` indexes, you'll have to create a script on the corresponding (main or CI) cluster to reindex using `REINDEX CONCURRENTLY`.
    <%- end -%>

    1. [ ] Destroy the VMs once your work is complete:

        1. [ ] Edit your `config-mgmt/environments/db-benchmarking/main.tf` file and remove the `nodes` map for the `amcheck` modules.

        1. [ ] Apply the config:

            ```sh
            cd environments/db-benchmarking
            tf apply --target=module.patroni-amcheck-main-<%= env %> --target=module.patroni-amcheck-ci-<%= env %>
            ```

            The plan should show that it'll destroy all resources for `module.patroni-amcheck-*`.

        1. [ ] File an MR for your change to the `main.tf` file and get it reviewed/merged.
